; This file is automaticaly generated. Do not edit!

; *** Literal Code ***


(define (token-type-to-arity token)
  (case token
    ((postfix-typeop prefix-typeop postfix-op prefix-op postfix-jct prefix-jct)
     1)
    ((prod-typeop tensor-typeop sum-typeop binding-op add-op mul-op exp-op
      rel-op and-op or-op imp-op pair-op and-jct or-jct tensor-jct imp-jct)
     2)
    (else 0)))

(define (alg-name-to-token-value alg-name)
  (let ((token-type (alg-name-to-token-type alg-name)))
    (case (token-type-to-arity token-type)
      ((0) alg-name)
      ((1) (lambda (x) (make-alg alg-name x)))
      ((2) (lambda (x y) (make-alg alg-name x y)))
      (else (myerror "unexpected arity" token-type)))))

(define (const-to-token-value const)
  (let ((token-type (const-to-token-type const)))
    (case (token-type-to-arity token-type)
      ((0) (make-term-in-const-form const))
      ((1) (lambda (x)
	     (make-term-in-app-form
	      (make-term-in-const-form const) x)))
      ((2) (lambda (x y)
	     (make-term-in-app-form
	      (make-term-in-app-form
	       (make-term-in-const-form const) x) y)))
      (else (myerror "unexpected arity" token-type)))))

; added 01-07-14
(define (const-and-token-type-to-token-value const token-type)
  (case (token-type-to-arity token-type)
    ((0) (make-term-in-const-form const))
    ((1) (lambda (x)
	   (make-term-in-app-form
	    (make-term-in-const-form const) x)))
    ((2) (lambda (x y)
	   (make-term-in-app-form
	    (make-term-in-app-form
	     (make-term-in-const-form const) x) y)))
    (else (myerror "unexpected arity" token-type))))

(define (token-type-to-precedence token-type)
  (case token-type
    ((binding-op bindterm) 1)
    ((pair-op term) 2)
    ((imp-op impterm) 3)
    ((or-op orterm) 4)
    ((and-op andterm) 5)
    ((rel-op relterm) 6)
    ((add-op addterm) 7)
    ((mul-op multerm) 8)
    ((exp-op expterm) 9)
    ((appterm) 10)
    ((prefix-op preterm) 11)
    ((postfix-op postterm) 12)
    ((const var number rec-op grec-op grecguard-op
	    corec-op destr-op if-op atomic-term) 13)
    (else (myerror
	   "token-type-to-precendence: token type expected" token-type))))

(define (left-assoc? token-type)
  (memq token-type
	'(add-op addterm mul-op multerm exp-op expterm appterm)))

(define (right-assoc? token-type)
  (memq token-type
	'(pair-op term imp-op impterm and-op andterm or-op orterm)))

(define (type-var-name-to-type type-var-name)
  (if (eq? (car type-var-name) #f)
      (myerror "Unknown variable name " (cdr type-var-name))
      (car type-var-name)))

(define (type-var-name-to-name type-var-name)
  (cdr type-var-name))

(define (pt string)
  (let ((t (pf string)))
    (if (eq? (car t) 'atom)
	(cadr t)
	(myerror "pt: term expected" t))))

(define (py string)
  (let ((t (pt string)))
    (if (eq? (car t) 'term-in-var-form)
	(cadr t)
	(myerror "py: type expected" t))))

(define (pv string)
  (let ((t (pt string)))
    (if (eq? (car t) 'term-in-var-form)
	(term-in-var-form-to-var t)
	(myerror "pv: variable expected" t))))

; *** Token Definitions ***
(define token-nrs
  (list 
   (cons '*EOI* 0)
   (cons 'number 1)
   (cons 'var-index 2)
   (cons 'tvar-name 3)
   (cons 'tconst 4)
   (cons 'var-name 5)
   (cons 'const 6)
   (cons 'pvar-name 7)
   (cons 'pvar-op 8)
   (cons 'pred-infix 9)
   (cons 'predconst-name 10)
   (cons 'idpredconst-name 11)
   (cons 'idpredconstscheme-name 12)
   (cons 'idpredconstscheme-name-wit 13)
   (cons 'type-symbol 14)
   (cons 'alg 15)
   (cons 'constscheme 16)
   (cons 'alg-typeop 17)
   (cons 'postfix-typeop 18)
   (cons 'prefix-typeop 19)
   (cons 'prod-typeop 20)
   (cons 'tensor-typeop 21)
   (cons 'sum-typeop 22)
   (cons 'arrow 23)
   (cons 'postfix-op 24)
   (cons 'prefix-op 25)
   (cons 'rec-op 26)
   (cons 'grec-op 27)
   (cons 'grecguard-op 28)
   (cons 'corec-op 29)
   (cons 'destr-op 30)
   (cons 'binding-op 31)
   (cons 'add-op 32)
   (cons 'mul-op 33)
   (cons 'exp-op 34)
   (cons 'rel-op 35)
   (cons 'and-op 36)
   (cons 'or-op 37)
   (cons 'imp-op 38)
   (cons 'pair-op 39)
   (cons 'pairscheme-op 40)
   (cons 'cterm-op 41)
   (cons 'if-op 42)
   (cons 'postfix-jct 43)
   (cons 'prefix-jct 44)
   (cons 'and-jct 45)
   (cons 'or-jct 46)
   (cons 'tensor-jct 47)
   (cons 'imp-jct 48)
   (cons 'quantor 49)
   (cons 'dot 50)
   (cons 'hat 51)
   (cons 'underscore 52)
   (cons 'comma 53)
   (cons 'semicolon 54)
   (cons 'prime 55)
   (cons 'hatprime 56)
   (cons 'hatprimeunderscore 57)
   (cons 'hatunderscore 58)
   (cons 'primeunderscore 59)
   (cons 'lpar 60)
   (cons 'rpar 61)
   (cons 'lbracket 62)
   (cons 'rbracket 63)
   (cons 'lcurl 64)
   (cons 'rcurl 65)
   (cons 'undefined-token 66)
   (cons 'string 67)
   (cons 'mpc-mpc 68)
   (cons 'mpc-proof 69)
   (cons 'mpc-classic 70)
   (cons 'mpc-intuitionistic 71)
   (cons 'mpc-end 72)
   (cons 'mpc-load 73)
   (cons 'mpc-include 74)
   (cons 'mpc-scheme 75)
   (cons 'mpc-type 76)
   (cons 'mpc-pred 77)
   (cons 'mpc-algebra 78)
   (cons 'mpc-function 79)
   (cons 'mpc-partial 80)
   (cons 'mpc-rewrite 81)
   (cons 'mpc-syntax 82)
   (cons 'mpc-op 83)
  ))

(define token-defs
  (vector 
 "*EOI*"
 "number"
 "var-index"
 "tvar-name"
 "tconst"
 "var-name"
 "const"
 "pvar-name"
 "pvar-op"
 "pred-infix"
 "predconst-name"
 "idpredconst-name"
 "idpredconstscheme-name"
 "idpredconstscheme-name-wit"
 "type-symbol"
 "alg"
 "constscheme"
 "alg-typeop"
 "postfix-typeop"
 "prefix-typeop"
 "prod-typeop"
 "tensor-typeop"
 "sum-typeop"
 "arrow"
 "postfix-op"
 "prefix-op"
 "rec-op"
 "grec-op"
 "grecguard-op"
 "corec-op"
 "destr-op"
 "binding-op"
 "add-op"
 "mul-op"
 "exp-op"
 "rel-op"
 "and-op"
 "or-op"
 "imp-op"
 "pair-op"
 "pairscheme-op"
 "cterm-op"
 "if-op"
 "postfix-jct"
 "prefix-jct"
 "and-jct"
 "or-jct"
 "tensor-jct"
 "imp-jct"
 "quantor"
 "dot"
 "hat"
 "underscore"
 "comma"
 "semicolon"
 "prime"
 "hatprime"
 "hatprimeunderscore"
 "hatunderscore"
 "primeunderscore"
 "lpar"
 "rpar"
 "lbracket"
 "rbracket"
 "lcurl"
 "rcurl"
 "undefined-token"
 "string"
 "mpc-mpc"
 "mpc-proof"
 "mpc-classic"
 "mpc-intuitionistic"
 "mpc-end"
 "mpc-load"
 "mpc-include"
 "mpc-scheme"
 "mpc-type"
 "mpc-pred"
 "mpc-algebra"
 "mpc-function"
 "mpc-partial"
 "mpc-rewrite"
 "mpc-syntax"
 "mpc-op"
  ))

; *** Action Table ***
(define action-table
  '#(
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (7 . 48) (8 . 49) (10 . 50) (11 . 51) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (44 . 57) (49 . 58) (60 . 59) (62 . 60) (68 . 61))
     ((default . *error*) (0 . 62))
     ((default . -2))
     ((default . -4))
     ((default . -7) (48 . 63))
     ((default . -6))
     ((default . -9) (47 . 64))
     ((default . -11))
     ((default . -13) (46 . 65))
     ((default . -15) (46 . 66))
     ((default . -19) (45 . 67))
     ((default . -17) (45 . 68))
     ((default . -25) (43 . 69))
     ((default . -27))
     ((default . -30))
     ((default . -31))
     ((default . -34))
     ((default . -34))
     ((default . -60) (2 . 72) (51 . 73) (52 . 74) (55 . 75) (56 . 76) (57 . 77) (58 . 78) (59 . 79))
     ((default . -157))
     ((default . -92) (2 . 80) (51 . 81) (52 . 82))
     ((default . -105) (23 . 83))
     ((default . -107) (22 . 84))
     ((default . -109) (21 . 85))
     ((default . -112) (3 . 44) (4 . 45) (15 . 52) (20 . 87) (60 . 88))
     ((default . -113) (20 . 89))
     ((default . -117) (18 . 90))
     ((default . -119))
     ((default . -120))
     ((default . -32) (9 . 91))
     ((default . -132) (39 . 93) (40 . 94))
     ((default . -134) (38 . 95))
     ((default . -136) (37 . 96))
     ((default . -138) (36 . 97))
     ((default . -140) (32 . 98) (35 . 99))
     ((default . -142) (33 . 100))
     ((default . -144) (34 . 101))
     ((default . -146) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 103) (60 . 104) (62 . 105))
     ((default . -148))
     ((default . -150))
     ((default . -152) (24 . 106))
     ((default . -154))
     ((default . -3))
     ((default . -158))
     ((default . -126) (2 . 107))
     ((default . -121))
     ((default . -86) (2 . 108) (51 . 109) (52 . 110))
     ((default . -156))
     ((default . -44) (2 . 111) (51 . 112) (52 . 113) (55 . 114) (56 . 115) (57 . 116) (58 . 117) (59 . 118))
     ((default . -82))
     ((default . -34) (2 . 120) (52 . 121))
     ((default . -34))
     ((default . -122))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (60 . 88))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (19 . 54) (60 . 88))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (60 . 104) (62 . 105))
     ((default . *error*) (3 . 44) (4 . 45) (5 . 46) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (7 . 48) (8 . 49) (10 . 50) (11 . 51) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (44 . 57) (49 . 58) (60 . 59) (62 . 60))
     ((default . *error*) (3 . 44) (4 . 45) (5 . 46) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (7 . 48) (8 . 134) (10 . 50) (11 . 51) (12 . 135) (13 . 136) (15 . 52) (16 . 137) (17 . 53) (19 . 54) (25 . 55) (26 . 138) (27 . 139) (28 . 140) (29 . 141) (30 . 142) (31 . 56) (44 . 57) (49 . 58) (60 . 59) (62 . 60))
     ((default . *error*) (3 . 44) (4 . 45) (5 . 46) (15 . 52) (17 . 53) (19 . 54) (42 . 144) (60 . 88))
     ((default . *error*) (54 . 145))
     ((default . -1) (0 . accept))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (7 . 48) (8 . 49) (10 . 50) (11 . 51) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (44 . 57) (49 . 58) (60 . 59) (62 . 60))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (7 . 48) (8 . 49) (10 . 50) (11 . 51) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (44 . 57) (49 . 58) (60 . 59) (62 . 60))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (7 . 48) (8 . 49) (10 . 50) (11 . 51) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (44 . 150) (49 . 151) (60 . 59) (62 . 60))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (7 . 48) (8 . 49) (10 . 50) (11 . 51) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (44 . 150) (49 . 151) (60 . 59) (62 . 60))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (7 . 48) (8 . 49) (10 . 50) (11 . 51) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (44 . 150) (49 . 151) (60 . 59) (62 . 60))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (7 . 48) (8 . 49) (10 . 50) (11 . 51) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (44 . 150) (49 . 151) (60 . 59) (62 . 60))
     ((default . -26))
     ((default . -41) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (60 . 104) (62 . 105))
     ((default . -28) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (60 . 104) (62 . 105))
     ((default . -61))
     ((default . -63) (2 . 156))
     ((default . -65) (2 . 157))
     ((default . -66) (2 . 158))
     ((default . -68) (2 . 159))
     ((default . -75) (2 . 160))
     ((default . -72) (2 . 161))
     ((default . -71) (2 . 162))
     ((default . -93))
     ((default . -95) (2 . 163))
     ((default . -97) (2 . 164) (5 . 165))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . -114))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . -118))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (60 . 104) (62 . 60))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (60 . 104) (62 . 60))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (60 . 104) (62 . 60))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 103) (60 . 104) (62 . 105))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 103) (60 . 104) (62 . 105))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 103) (60 . 104) (62 . 105))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 103) (60 . 104) (62 . 105))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 103) (60 . 104) (62 . 105))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 103) (60 . 104) (62 . 105))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 103) (60 . 104) (62 . 105))
     ((default . -147))
     ((default . *error*) (3 . 44) (4 . 45) (5 . 46) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (16 . 137) (17 . 53) (19 . 54) (25 . 55) (26 . 138) (27 . 139) (28 . 140) (29 . 141) (30 . 142) (31 . 56) (60 . 104) (62 . 60))
     ((default . *error*) (42 . 144))
     ((default . -153))
     ((default . -127))
     ((default . -87))
     ((default . -89) (2 . 186))
     ((default . -91) (2 . 187))
     ((default . -45))
     ((default . -47) (2 . 188))
     ((default . -49) (2 . 189))
     ((default . -50) (2 . 190))
     ((default . -53) (2 . 191))
     ((default . -59) (2 . 192))
     ((default . -56) (2 . 193))
     ((default . -55) (2 . 194))
     ((default . -36) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (60 . 104) (62 . 105))
     ((default . -34))
     ((default . -34) (2 . 197))
     ((default . -40) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (60 . 104) (62 . 105))
     ((default . -115))
     ((default . -116))
     ((default . -151))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (50 . 199) (60 . 104) (62 . 105))
     ((default . -85) (53 . 200))
     ((default . -22))
     ((default . -24))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (7 . 48) (8 . 49) (10 . 50) (11 . 51) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (44 . 57) (49 . 58) (50 . 203) (60 . 59) (62 . 60))
     ((default . *error*) (61 . 204))
     ((default . -92) (2 . 80) (51 . 81) (52 . 82) (61 . 205))
     ((default . -32) (9 . 91) (61 . 206))
     ((default . -82) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 212))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . *error*) (1 . 215) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . *error*) (1 . 218) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . *error*) (63 . 221))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (60 . 104) (62 . 105))
     ((default . -172))
     ((default . -5))
     ((default . -8))
     ((default . -10))
     ((default . -12))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (7 . 48) (8 . 49) (10 . 50) (11 . 51) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (44 . 150) (49 . 151) (60 . 59) (62 . 60))
     ((default . *error*) (3 . 44) (4 . 45) (5 . 46) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . -14))
     ((default . -18))
     ((default . -16))
     ((default . -35))
     ((default . -62))
     ((default . -64))
     ((default . -67))
     ((default . -69))
     ((default . -74))
     ((default . -73))
     ((default . -70))
     ((default . -94))
     ((default . -96))
     ((default . -98) (2 . 226) (51 . 227) (52 . 228))
     ((default . -104))
     ((default . -106))
     ((default . -108))
     ((default . -110))
     ((default . *error*) (61 . 205))
     ((default . -111))
     ((default . -29))
     ((default . -129))
     ((default . -128))
     ((default . -124))
     ((default . -170) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . -133))
     ((default . -135))
     ((default . -137))
     ((default . -141) (33 . 100))
     ((default . -139) (32 . 98))
     ((default . -143) (34 . 101))
     ((default . -145) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 103) (60 . 104) (62 . 105))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (60 . 104) (62 . 105))
     ((default . *error*) (61 . 206))
     ((default . -88))
     ((default . -90))
     ((default . -46))
     ((default . -48))
     ((default . -51))
     ((default . -52))
     ((default . -58))
     ((default . -57))
     ((default . -54))
     ((default . -37) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (60 . 104) (62 . 105))
     ((default . -39) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (60 . 104) (62 . 105))
     ((default . -34))
     ((default . -149))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (60 . 104) (62 . 60))
     ((default . *error*) (3 . 44) (4 . 45) (5 . 46) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . -21))
     ((default . -23))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (7 . 48) (8 . 49) (10 . 50) (11 . 51) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (44 . 57) (49 . 58) (60 . 59) (62 . 60))
     ((default . -33))
     ((default . -123))
     ((default . -155))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88) (61 . 234))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 212) (61 . 236))
     ((default . -80))
     ((default . *error*) (60 . 238) (61 . 239))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 212))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (41 . 241) (60 . 88))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88) (61 . 242))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88) (61 . 243))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88) (61 . 245))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88) (61 . 246))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88) (61 . 248))
     ((default . *error*) (61 . 249))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (60 . 104) (62 . 60))
     ((default . -168))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (60 . 104) (62 . 105) (63 . 252))
     ((default . -171) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (7 . 48) (8 . 49) (10 . 50) (11 . 51) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (44 . 57) (49 . 58) (60 . 59) (62 . 60) (64 . 264) (69 . 265) (70 . 266) (71 . 267) (72 . 268) (73 . 269) (74 . 270) (75 . 271) (76 . 272) (77 . 273) (78 . 274) (79 . 275) (80 . 276) (82 . 277) (54 . -187))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (7 . 48) (8 . 49) (10 . 50) (11 . 51) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (44 . 150) (49 . 151) (60 . 59) (62 . 60))
     ((default . -99))
     ((default . -101) (2 . 278))
     ((default . -103) (2 . 279))
     ((default . -125))
     ((default . -38) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (60 . 104) (62 . 105))
     ((default . -130))
     ((default . -84))
     ((default . -20))
     ((default . -83))
     ((default . *error*) (60 . 238) (61 . 280))
     ((default . -77))
     ((default . -81))
     ((default . *error*) (41 . 241))
     ((default . -42))
     ((default . *error*) (60 . 238) (61 . 281))
     ((default . *error*) (60 . 282))
     ((default . -166))
     ((default . -159))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88) (61 . 283))
     ((default . -161))
     ((default . -162))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88) (61 . 284))
     ((default . -164))
     ((default . -165))
     ((default . -131))
     ((default . -169))
     ((default . -167))
     ((default . -188) (50 . -189))
     ((default . -92) (2 . 80) (51 . 81) (52 . 82) (50 . 285))
     ((default . -173))
     ((default . *error*) (54 . 286))
     ((default . *error*) (54 . 287))
     ((default . *error*) (50 . 288))
     ((default . -177))
     ((default . *error*) (54 . 289))
     ((default . *error*) (64 . 290))
     ((default . -202) (64 . 292))
     ((default . *error*) (54 . 293))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (7 . 48) (8 . 49) (10 . 50) (11 . 51) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (44 . 57) (49 . 58) (60 . 59) (62 . 60))
     ((default . -183))
     ((default . *error*) (69 . 296))
     ((default . *error*) (69 . 297))
     ((default . -186))
     ((default . *error*) (67 . 298))
     ((default . *error*) (67 . 299))
     ((default . *error*) (67 . 300))
     ((default . *error*) (50 . 301))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (50 . 303) (60 . 88))
     ((default . *error*) (66 . 305))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . *error*) (79 . 307))
     ((default . *error*) (24 . 309) (25 . 310) (32 . 311) (33 . 312) (35 . 313) (36 . 314) (37 . 315) (38 . 316) (39 . 317) (66 . 318))
     ((default . -100))
     ((default . -102))
     ((default . -76))
     ((default . -43))
     ((default . *error*) (3 . 44) (4 . 45) (5 . 46) (15 . 52) (17 . 53) (19 . 54) (60 . 88) (61 . 320))
     ((default . -160))
     ((default . -163))
     ((default . *error*) (66 . 305))
     ((default . -174))
     ((default . -176))
     ((default . -175))
     ((default . -178))
     ((default . -209) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . -214))
     ((default . -203))
     ((default . -179))
     ((default . *error*) (50 . 326))
     ((default . -187) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (7 . 48) (8 . 49) (10 . 50) (11 . 51) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (44 . 57) (49 . 58) (60 . 59) (62 . 60) (64 . 264))
     ((default . -184))
     ((default . -185))
     ((default . -180))
     ((default . -181))
     ((default . -182))
     ((default . *error*) (66 . 305))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (50 . 332) (60 . 88))
     ((default . *error*) (66 . 305))
     ((default . -206) (1 . 334))
     ((default . -207) (66 . 305))
     ((default . *error*) (50 . 336))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . *error*) (83 . 338))
     ((default . -229))
     ((default . -228))
     ((default . -226))
     ((default . -227))
     ((default . -225))
     ((default . -224))
     ((default . -223))
     ((default . -222))
     ((default . -221))
     ((default . -220))
     ((default . *error*) (61 . 339))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (7 . 48) (8 . 49) (10 . 50) (11 . 51) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (44 . 57) (49 . 58) (60 . 59) (62 . 60))
     ((default . -197))
     ((default . *error*) (50 . 341))
     ((default . *error*) (65 . 342))
     ((default . -209) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (60 . 104) (62 . 60) (65 . 348) (81 . 349) (82 . 277))
     ((default . -191))
     ((default . -188))
     ((default . *error*) (54 . 350))
     ((default . -193))
     ((default . -187) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (7 . 48) (8 . 49) (10 . 50) (11 . 51) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (44 . 57) (49 . 58) (60 . 59) (62 . 60) (64 . 264) (65 . 353))
     ((default . -196))
     ((default . *error*) (66 . 305))
     ((default . -199))
     ((default . -205))
     ((default . -208))
     ((default . *error*) (66 . 355))
     ((default . *error*) (50 . 356))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (60 . 104) (62 . 60))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (7 . 48) (8 . 49) (10 . 50) (11 . 51) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (44 . 57) (49 . 58) (60 . 59) (62 . 60))
     ((default . *error*) (61 . 359))
     ((default . *error*) (66 . 360))
     ((default . -200))
     ((default . -210))
     ((default . *error*) (48 . 361))
     ((default . -201))
     ((default . -215))
     ((default . *error*) (54 . 362))
     ((default . -204))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (60 . 104) (62 . 60))
     ((default . -192))
     ((default . *error*) (54 . 364))
     ((default . -194))
     ((default . -190))
     ((default . -198))
     ((default . *error*) (60 . 365))
     ((default . *error*) (66 . 366))
     ((default . -219))
     ((default . *error*) (61 . 367))
     ((default . -79))
     ((default . *error*) (54 . 368))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (60 . 104) (62 . 60))
     ((default . -216))
     ((default . *error*) (48 . 370))
     ((default . -195))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . *error*) (60 . 372))
     ((default . -78))
     ((default . -211))
     ((default . *error*) (54 . 373))
     ((default . *error*) (1 . 43) (3 . 44) (4 . 45) (5 . 46) (6 . 47) (15 . 52) (17 . 53) (19 . 54) (25 . 55) (31 . 56) (60 . 104) (62 . 60))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88) (61 . 375))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88))
     ((default . -217))
     ((default . *error*) (54 . 377))
     ((default . -212))
     ((default . *error*) (3 . 44) (4 . 45) (15 . 52) (17 . 53) (19 . 54) (60 . 88) (61 . 378))
     ((default . -218))
     ((default . -213))
    ))

; *** Goto Table ***
(define goto-table
  '#(
     ((49 . 42)(46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 29)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19)(21 . 18)(18 . 17)(17 . 16)(16 . 15)(15 . 14)(13 . 13)(12 . 12)(11 . 11)(10 . 10)(9 . 9)(8 . 8)(7 . 7)(6 . 6)(5 . 5)(4 . 4)(3 . 3)(2 . 2)(1 . 1))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((14 . 70))
     ((14 . 71))
     ()
     ()
     ()
     ()
     ()
     ()
     ((33 . 28)(31 . 86))
     ()
     ()
     ()
     ()
     ()
     ((48 . 92))
     ()
     ()
     ()
     ()
     ()
     ()
     ((46 . 41)(45 . 40)(44 . 39)(43 . 102)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((14 . 119))
     ((14 . 122))
     ()
     ((33 . 28)(31 . 123))
     ((33 . 28)(31 . 27)(30 . 26)(29 . 124))
     ((46 . 41)(45 . 40)(44 . 125)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 127)(22 . 126))
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 29)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19)(21 . 18)(18 . 17)(17 . 16)(16 . 15)(15 . 14)(13 . 13)(12 . 12)(11 . 129)(10 . 128))
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 127)(22 . 130))
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 133)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 132)(23 . 19)(21 . 18)(18 . 17)(17 . 16)(16 . 15)(15 . 14)(13 . 13)(12 . 12)(11 . 11)(10 . 10)(9 . 9)(8 . 8)(7 . 7)(6 . 6)(5 . 5)(4 . 4)(3 . 3)(2 . 131))
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 127)(22 . 143))
     ()
     ()
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 29)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19)(21 . 18)(18 . 17)(17 . 16)(16 . 15)(15 . 14)(13 . 13)(12 . 12)(11 . 11)(10 . 10)(9 . 9)(8 . 8)(7 . 7)(6 . 6)(5 . 5)(4 . 4)(3 . 146))
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 29)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19)(21 . 18)(18 . 17)(17 . 16)(16 . 15)(15 . 14)(13 . 13)(12 . 12)(11 . 11)(10 . 10)(9 . 9)(8 . 8)(7 . 7)(6 . 6)(5 . 148)(4 . 147))
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 29)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19)(21 . 18)(18 . 17)(17 . 16)(16 . 15)(15 . 14)(13 . 13)(12 . 12)(11 . 11)(8 . 8)(6 . 149))
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 29)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19)(21 . 18)(18 . 17)(17 . 16)(16 . 15)(15 . 14)(13 . 13)(12 . 12)(11 . 11)(8 . 8)(6 . 152))
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 29)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19)(21 . 18)(18 . 17)(17 . 16)(16 . 15)(15 . 14)(13 . 13)(12 . 12)(11 . 11)(8 . 153))
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 29)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19)(21 . 18)(18 . 17)(17 . 16)(16 . 15)(15 . 14)(13 . 13)(12 . 12)(11 . 11)(8 . 154))
     ()
     ((46 . 155)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ((46 . 155)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 166))
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 167))
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 168))
     ()
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 169))
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 170))
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 171))
     ()
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 172)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 173)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 174)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ((33 . 28)(32 . 176)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 175))
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 177)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 178)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 179)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 180)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 181)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 182)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 183)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ()
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 127)(22 . 184))
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 185)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 132)(23 . 19))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((46 . 155)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ((14 . 195))
     ((14 . 196))
     ((46 . 155)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ()
     ()
     ()
     ((46 . 41)(45 . 40)(44 . 198)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ()
     ()
     ()
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 29)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19)(21 . 18)(18 . 17)(17 . 16)(16 . 15)(15 . 14)(13 . 13)(12 . 12)(11 . 202)(10 . 201))
     ()
     ()
     ()
     ((33 . 28)(32 . 207)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 175))
     ((33 . 28)(32 . 208)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 175))
     ((33 . 28)(32 . 211)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 175)(20 . 210)(19 . 209))
     ((33 . 28)(32 . 213)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 175))
     ((33 . 28)(32 . 214)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 175))
     ((33 . 28)(32 . 216)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 175))
     ((33 . 28)(32 . 217)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 175))
     ((33 . 28)(32 . 219)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 175))
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 220))
     ()
     ((47 . 223)(46 . 222)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ((50 . 224))
     ()
     ()
     ()
     ()
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 29)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19)(21 . 18)(18 . 17)(17 . 16)(16 . 15)(15 . 14)(13 . 13)(12 . 12)(11 . 129))
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 127)(22 . 225))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 229))
     ()
     ()
     ()
     ()
     ()
     ()
     ((46 . 41)(45 . 40)(44 . 39)(43 . 102)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ((46 . 41)(45 . 40)(44 . 198)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((46 . 155)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ((46 . 155)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ((14 . 230))
     ()
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 231)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 127)(22 . 232))
     ()
     ()
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 29)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19)(21 . 18)(18 . 17)(17 . 16)(16 . 15)(15 . 14)(13 . 13)(12 . 12)(11 . 11)(10 . 10)(9 . 9)(8 . 8)(7 . 7)(6 . 6)(5 . 5)(4 . 4)(3 . 3)(2 . 233))
     ()
     ()
     ()
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 229))
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 229)(20 . 235)(19 . 209))
     ()
     ((19 . 237))
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 229)(20 . 240)(19 . 209))
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 170))
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 229))
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 229))
     ((33 . 28)(32 . 244)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 175))
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 229))
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 229))
     ((33 . 28)(32 . 247)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 175))
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 229))
     ()
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 250)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ()
     ((46 . 251)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ((68 . 263)(65 . 262)(61 . 261)(58 . 260)(55 . 259)(54 . 258)(53 . 257)(52 . 256)(51 . 255)(46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 29)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 254)(23 . 19)(21 . 18)(18 . 17)(17 . 16)(16 . 15)(15 . 14)(13 . 13)(12 . 12)(11 . 11)(10 . 10)(9 . 9)(8 . 8)(7 . 7)(6 . 6)(5 . 5)(4 . 4)(3 . 3)(2 . 253))
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 29)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19)(21 . 18)(18 . 17)(17 . 16)(16 . 15)(15 . 14)(13 . 13)(12 . 12)(11 . 202))
     ()
     ()
     ()
     ()
     ((46 . 155)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ()
     ()
     ()
     ()
     ((19 . 237))
     ()
     ()
     ()
     ()
     ((19 . 237))
     ()
     ()
     ()
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 229))
     ()
     ()
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 229))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((59 . 291))
     ()
     ((56 . 295)(46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 29)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19)(21 . 18)(18 . 17)(17 . 16)(16 . 15)(15 . 14)(13 . 13)(12 . 12)(11 . 11)(10 . 10)(9 . 9)(8 . 8)(7 . 7)(6 . 6)(5 . 5)(4 . 4)(3 . 3)(2 . 294))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((33 . 28)(32 . 302)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 175))
     ((62 . 304))
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 306))
     ()
     ((69 . 308))
     ()
     ()
     ()
     ()
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 127)(22 . 319))
     ()
     ()
     ((62 . 321))
     ()
     ()
     ()
     ()
     ((64 . 324)(63 . 323)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 322))
     ((66 . 325))
     ()
     ()
     ()
     ((57 . 330)(55 . 329)(53 . 328)(46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 29)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19)(21 . 18)(18 . 17)(17 . 16)(16 . 15)(15 . 14)(13 . 13)(12 . 12)(11 . 11)(10 . 10)(9 . 9)(8 . 8)(7 . 7)(6 . 6)(5 . 5)(4 . 4)(3 . 3)(2 . 327))
     ()
     ()
     ()
     ()
     ()
     ((62 . 331))
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 229))
     ((62 . 333))
     ()
     ((62 . 335))
     ()
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 337))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 29)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19)(21 . 18)(18 . 17)(17 . 16)(16 . 15)(15 . 14)(13 . 13)(12 . 12)(11 . 11)(10 . 10)(9 . 9)(8 . 8)(7 . 7)(6 . 6)(5 . 5)(4 . 4)(3 . 3)(2 . 340))
     ()
     ()
     ()
     ((64 . 324)(63 . 343)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 322))
     ((68 . 347)(67 . 346)(60 . 345)(46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 344)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ()
     ()
     ()
     ()
     ((55 . 352)(53 . 351)(46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 29)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19)(21 . 18)(18 . 17)(17 . 16)(16 . 15)(15 . 14)(13 . 13)(12 . 12)(11 . 11)(10 . 10)(9 . 9)(8 . 8)(7 . 7)(6 . 6)(5 . 5)(4 . 4)(3 . 3)(2 . 327))
     ()
     ((62 . 354))
     ()
     ()
     ()
     ()
     ()
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 357)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 29)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19)(21 . 18)(18 . 17)(17 . 16)(16 . 15)(15 . 14)(13 . 13)(12 . 12)(11 . 11)(10 . 10)(9 . 9)(8 . 8)(7 . 7)(6 . 6)(5 . 5)(4 . 4)(3 . 3)(2 . 358))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 363)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 369)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ()
     ()
     ()
     ((33 . 28)(32 . 371)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 175))
     ()
     ()
     ()
     ()
     ((46 . 41)(45 . 40)(44 . 39)(43 . 38)(42 . 37)(41 . 36)(40 . 35)(39 . 34)(38 . 33)(37 . 32)(36 . 31)(35 . 30)(34 . 374)(33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 20)(23 . 19))
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 229))
     ((33 . 28)(32 . 376)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 175))
     ()
     ()
     ()
     ((33 . 28)(31 . 27)(30 . 26)(29 . 25)(28 . 24)(27 . 23)(26 . 22)(25 . 21)(24 . 229))
     ()
     ()
    ))

; *** Reduction Table ***
(define reduction-table
  (vector
    '()
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (accept $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 1 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 1 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 2 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 3 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 3 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 3 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 4 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 4 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 5 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 5 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 6 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 6 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 7 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 7 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 8 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 8 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 9 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 9 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 10 goto-table ($1 $2 $4))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 10 goto-table ($1 $2 $3))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 10 goto-table ($1 $2))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 11 goto-table ($1 $2 $3))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 11 goto-table ($1 $2))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 11 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 12 goto-table ($2 $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 12 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 13 goto-table (apply make-predicate-formula (cons $1 $2)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 13 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 13 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 13 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 13 goto-table (make-atomic-formula $1))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 13 goto-table $2)))
    (lambda (stack sp goto-table)
      (let* ()
          (push stack (- sp 0) 14 goto-table (quote ()))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 14 goto-table (append $1 (list $2)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 15 goto-table (apply $1 (cons -1 $2)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 15 goto-table (apply $1 (cons $2 $3)))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 15 goto-table (apply $1 (cons $3 $4)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 15 goto-table (apply $1 (cons -1 $3)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 16 goto-table (apply $1 $2))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 16 goto-table (apply $1 $2))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 17 goto-table ($2 $3))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 17 goto-table ($2 $4))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 18 goto-table (make-pvar (car $1) -1 h-deg-zero n-deg-zero (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) $2 h-deg-zero n-deg-zero (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 h-deg-one n-deg-zero (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 h-deg-one n-deg-zero (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 h-deg-zero n-deg-zero (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 h-deg-zero n-deg-zero (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 h-deg-zero n-deg-one (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 h-deg-zero n-deg-one (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 h-deg-one n-deg-one (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 h-deg-one n-deg-one (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 h-deg-zero n-deg-one (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 h-deg-zero n-deg-one (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 h-deg-one n-deg-zero (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 h-deg-one n-deg-zero (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 h-deg-one n-deg-one (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 h-deg-one n-deg-one (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 18 goto-table (make-pvar $1 -1 h-deg-zero n-deg-zero ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 $2 h-deg-zero n-deg-zero ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 h-deg-one n-deg-zero ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 h-deg-one n-deg-zero ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 h-deg-zero n-deg-zero ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 h-deg-zero n-deg-zero ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 h-deg-zero n-deg-one ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 h-deg-zero n-deg-one ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 h-deg-one n-deg-one ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 h-deg-one n-deg-one ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 h-deg-zero n-deg-one ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 h-deg-zero n-deg-one ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 h-deg-one n-deg-zero ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 h-deg-one n-deg-zero ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 h-deg-one n-deg-one ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 h-deg-one n-deg-one ""))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 18 goto-table (idpredconst-name-and-types-and-cterms-to-idpredconst $2 $3 $4))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 18 goto-table (idpredconst-name-and-types-and-cterms-to-idpredconst $2 $3 (quote ())))))
    (lambda (stack sp goto-table)
      (let* (($7 (vector-ref stack (- sp 1)))
             ($6 (vector-ref stack (- sp 3)))
             ($5 (vector-ref stack (- sp 5)))
             ($4 (vector-ref stack (- sp 7)))
             ($3 (vector-ref stack (- sp 9)))
             ($2 (vector-ref stack (- sp 11)))
             ($1 (vector-ref stack (- sp 13))))
          (push stack (- sp 14) 19 goto-table (apply make-cterm (append $4 (list $6))))))
    (lambda (stack sp goto-table)
      (let* (($6 (vector-ref stack (- sp 1)))
             ($5 (vector-ref stack (- sp 3)))
             ($4 (vector-ref stack (- sp 5)))
             ($3 (vector-ref stack (- sp 7)))
             ($2 (vector-ref stack (- sp 9)))
             ($1 (vector-ref stack (- sp 11))))
          (push stack (- sp 12) 19 goto-table (make-cterm $5))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 20 goto-table (list $1))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 20 goto-table (append $1 (list $2)))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 21 goto-table (make-arity))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 21 goto-table (apply make-arity $3))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 22 goto-table (cons $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 22 goto-table (list $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 23 goto-table (make-var (type-var-name-to-type $1) -1 1 (type-var-name-to-name $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 23 goto-table (make-var (type-var-name-to-type $1) $2 1 (type-var-name-to-name $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 23 goto-table (make-var (type-var-name-to-type $1) $3 0 (type-var-name-to-name $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 23 goto-table (make-var (type-var-name-to-type $1) -1 0 (type-var-name-to-name $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 23 goto-table (make-var (type-var-name-to-type $1) $3 1 (type-var-name-to-name $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 23 goto-table (make-var (type-var-name-to-type $1) -1 1 (type-var-name-to-name $1)))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 23 goto-table (make-var $1 -1 1 ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 23 goto-table (make-var $1 $2 1 ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 23 goto-table (make-var $1 $3 0 ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 23 goto-table (make-var $1 -1 0 ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 23 goto-table (make-var $1 $3 1 ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 23 goto-table (make-var $1 -1 1 ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 23 goto-table (make-var $1 -1 1 (type-var-name-to-name $3)))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 23 goto-table (make-var $1 $4 1 (type-var-name-to-name $3)))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 23 goto-table (make-var $1 $5 0 (type-var-name-to-name $3)))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 23 goto-table (make-var $1 -1 0 (type-var-name-to-name $3)))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 23 goto-table (make-var $1 $5 1 (type-var-name-to-name $3)))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 23 goto-table (make-var $1 -1 1 (type-var-name-to-name $3)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 24 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 24 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 25 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 25 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 26 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 26 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 27 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 27 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 27 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 27 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 28 goto-table (apply make-alg (cons (alg-form-to-name $1) (append (alg-form-to-types $1) (list $2)))))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 28 goto-table (make-alg $1 $2))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 29 goto-table ($1 $2))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 29 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 30 goto-table ($2 $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 30 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 31 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 31 goto-table (make-tconst $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 31 goto-table (make-alg $1))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 31 goto-table $2)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 32 goto-table (list $1))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 32 goto-table (append $1 (list $2)))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 33 goto-table (make-tvar -1 $1))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 33 goto-table (make-tvar $2 $1))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 34 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 34 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 34 goto-table ($1 $2 $4))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 34 goto-table (apply mk-term-in-abst-form (append $2 (list $4))))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 34 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 35 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 35 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 36 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 36 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 37 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 37 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 38 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 38 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 39 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 39 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 40 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 40 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 41 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 41 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 42 goto-table (make-gen-application $1 $2))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 42 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 43 goto-table ($1 $2 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 43 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 44 goto-table ($1 $2))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 44 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 45 goto-table ($2 $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 45 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 46 goto-table $2)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 46 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 46 goto-table (make-term-in-var-form $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 46 goto-table (make-numeric-term $1))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 46 goto-table ($2 $3))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 46 goto-table ($2 (cons $3 $4)))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 46 goto-table ($2 $3))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 46 goto-table ($2 $3))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 46 goto-table ($2 (cons $3 $4)))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 46 goto-table ($2 $3))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 46 goto-table ($2 $3))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 46 goto-table (make-term-in-const-form (let* ((tvars (const-to-tvars $2)) (subst (make-substitution tvars $3))) (const-substitute $2 subst #f))))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 46 goto-table (make-term-in-if-form (car $3) (cdr $3)))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 47 goto-table (list $1))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 47 goto-table (append $1 (list $2)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 48 goto-table (lambda (x y) (make-term-in-app-form (make-term-in-app-form (make-term-in-const-form (let* ((tvars (const-to-tvars $1)) (subst (make-substitution tvars $2))) (const-substitute $1 subst #f))) x) y)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 49 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* ()
          (push stack (- sp 0) 50 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 50 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 51 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 51 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 51 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 51 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 51 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 51 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 52 goto-table (mpc-command-load $2))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 52 goto-table (mpc-command-include $2))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 52 goto-table (mpc-command-scheme $2))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 52 goto-table (mpc-start #f #f))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 52 goto-table (mpc-start #t #t))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 52 goto-table (mpc-start #t #f))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 52 goto-table (mpc-stop))))
    (lambda (stack sp goto-table)
      (let* ()
          (push stack (- sp 0) 53 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 53 goto-table (mpc-claim $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 54 goto-table (mpc-assume $1))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 55 goto-table (mpc-block-stop))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 56 goto-table (mpc-block-start $1))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 57 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 57 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 57 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 57 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 58 goto-table (mpc-declare-type $3))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 58 goto-table (mpc-declare-var $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 58 goto-table (mpc-declare-pred (apply make-arity $2) $4))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 58 goto-table (mpc-declare-pred (make-arity) $3))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 58 goto-table (mpc-declare-algebra (car $1) (cadr $1) (cddr $1) $3))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 58 goto-table (mpc-function))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 58 goto-table (mpc-function))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 59 goto-table (mpc-function-rules-start))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 60 goto-table (mpc-function-rules-stop))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 61 goto-table (mpc-declare-algebra-header $2 $3))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 61 goto-table (mpc-declare-algebra-header $2 0))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 62 goto-table (list $1))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 62 goto-table (cons $1 $2))))
    (lambda (stack sp goto-table)
      (let* ()
          (push stack (- sp 0) 63 goto-table (quote ()))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 63 goto-table (cons $1 $2))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 64 goto-table (list $3 $1))))
    (lambda (stack sp goto-table)
      (let* (($7 (vector-ref stack (- sp 1)))
             ($6 (vector-ref stack (- sp 3)))
             ($5 (vector-ref stack (- sp 5)))
             ($4 (vector-ref stack (- sp 7)))
             ($3 (vector-ref stack (- sp 9)))
             ($2 (vector-ref stack (- sp 11)))
             ($1 (vector-ref stack (- sp 13))))
          (push stack (- sp 14) 65 goto-table (mpc-declare-function $4 $6 $2 1))))
    (lambda (stack sp goto-table)
      (let* (($8 (vector-ref stack (- sp 1)))
             ($7 (vector-ref stack (- sp 3)))
             ($6 (vector-ref stack (- sp 5)))
             ($5 (vector-ref stack (- sp 7)))
             ($4 (vector-ref stack (- sp 9)))
             ($3 (vector-ref stack (- sp 11)))
             ($2 (vector-ref stack (- sp 13)))
             ($1 (vector-ref stack (- sp 15))))
          (push stack (- sp 16) 65 goto-table (mpc-declare-function $5 $7 $3 0))))
    (lambda (stack sp goto-table)
      (let* ()
          (push stack (- sp 0) 66 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 66 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 67 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 67 goto-table (mpc-computation-rule $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 67 goto-table (mpc-rewrite-rule $2 $4))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 68 goto-table (mpc-declare-syntax $2 (car $3) (cadr $3) (caddr $3) $4))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 69 goto-table current-token)))
  ))

; *** Parser Definition ***
(define parser
   (make-parser
    action-table
    goto-table
    reduction-table
    token-defs))

; *** Terminals Table ***

(define terminal-table
   `#(
   ()
   ()
   (("excl" 49 . ,(lambda (v k) (apply mk-excl (append v (list k))))))
   (("CONST" 83 . ,(list (quote const) "CONST" 0)))
   (("LOAD" 73)("=>" 23 . ,make-arrow))
   (("GRecGuard" 28 . ,(lambda (l) (make-term-in-const-form (type-info-to-grecguard-const l)))))
   (("cterm" 41))
   (("SYNTAX" 82))
   ()
   ()
   (("lambda" 31 . ,(lambda (varlist kernel) (apply mk-term-in-abst-form (append varlist (list kernel))))))
   (("excu" 49 . ,(lambda (v k) (apply mk-excu (append v (list k))))))
   ()
   ()
   ()
   (("IMPOP" 83 . ,(list (quote imp-op) "IMPOP" 2)))
   ()
   ()
   (("END" 72)("^'" 56))
   ()
   ()
   ()
   ()
   ()
   (("ADDOP" 83 . ,(list (quote add-op) "ADDOP" 2)))
   ()
   (("{" 64))
   (("^'_" 57)("@@" 20 . ,make-star))
   (("}" 65))
   (("OROP" 83 . ,(list (quote or-op) "OROP" 2)))
   ()
   ()
   ()
   (("!" 47 . ,make-tensor))
   ()
   (("MPC" 68))
   ()
   (("CLASSIC" 70))
   (("SCHEME" 75)("&" 45 . ,make-and))
   (("'" 55))
   (("(" 60)("allnc" 49 . ,(lambda (v k) (apply mk-allnc (append v (list k))))))
   ((")" 61))
   (("MULOP" 83 . ,(list (quote mul-op) "MULOP" 2))("REWRITE" 81)("Total" 10 . ,(string-and-arity-to-predconst-parse-function "Total" (make-arity (make-tvar -1 "alpha")))))
   (("PAIROP" 83 . ,(list (quote pair-op) "PAIROP" 2)))
   (("," 53))
   (("atomic" 4 . ,"atomic"))
   (("TYPE" 76)("." 50)("left" 25 . ,make-term-in-lcomp-form))
   ()
   (("PROOF" 69))
   ()
   (("INTUITIONISTIC" 71))
   (("ex" 49 . ,(lambda (v k) (apply mk-ex (append v (list k))))))
   ()
   ()
   ()
   ()
   ()
   ()
   (("INCLUDE" 74))
   (("ANDOP" 83 . ,(list (quote and-op) "ANDOP" 2))("FUNCTION" 79)(";" 54))
   (("RELOP" 83 . ,(list (quote rel-op) "RELOP" 2))("PARTIAL" 80)("-->" 48 . ,make-impnc)("TotalMR" 10 . ,(string-and-arity-to-predconst-parse-function "TotalMR" (make-arity (make-tvar -1 "alpha") (make-tvar -1 "alpha")))))
   (("if" 42)("=" 35 . ,(lambda (term1 term2) (let ((type1 (term-to-type term1)) (type2 (term-to-type term2))) (mk-term-in-app-form (make-term-in-const-form (finalg-to-=-const (if (equal? type1 type2) type1 (types-lub type1 type2)))) term1 term2)))))
   ()
   ()
   (("@" 39 . ,make-term-in-pair-form)("CoRec" 29 . ,(lambda (l) (make-term-in-const-form (apply alg-or-arrow-types-to-corec-const l)))))
   (("Pvar" 8))
   (("POSTFIXOP" 83 . ,(list (quote postfix-op) "POSTFIXOP" 1))("ALGEBRA" 78)("existential" 4 . ,"existential"))
   ()
   (("SE" 25 . ,(lambda (term) (make-term-in-app-form (make-term-in-const-form (sfinalg-to-se-const (term-to-type term))) term))))
   (("E" 25 . ,(lambda (term) (make-term-in-app-form (make-term-in-const-form (finalg-to-e-const (term-to-type term))) term)))("bot" 7 . ,(cons (make-arity) "bot")))
   (("exnc" 49 . ,(lambda (v k) (apply mk-exnc (append v (list k)))))("Equal" 10 . ,(string-and-arity-to-predconst-parse-function "Equal" (make-arity (make-tvar -1 "alpha") (make-tvar -1 "alpha")))))
   (("Rec" 26 . ,(lambda (l) (make-term-in-const-form (apply type-info-to-rec-const l)))))
   (("coRec" 29 . ,(lambda (l) (make-term-in-const-form (apply arrow-type-to-corec-const l)))))
   ()
   (("^_" 58))
   ()
   ()
   (("'_" 59)("GRec" 27 . ,(lambda (l) (make-term-in-const-form (type-info-to-grec-const l))))("prop" 4 . ,"prop"))
   ()
   (("right" 25 . ,make-term-in-rcomp-form))
   ()
   ()
   ()
   ()
   (("PREFIXOP" 83 . ,(list (quote prefix-op) "PREFIXOP" 1)))
   ()
   (("->" 48 . ,make-imp))
   ()
   (("exca" 49 . ,(lambda (v k) (apply mk-exca (append v (list k)))))("all" 49 . ,(lambda (v k) (apply mk-all (append v (list k))))))
   ()
   (("nulltype" 4 . ,"nulltype"))
   (("[" 62))
   ()
   (("]" 63)("Destr" 30 . ,(lambda (term) (make-term-in-const-form (alg-to-destr-const term)))))
   (("^" 51))
   (("_" 52)("alpha" 3 . ,"alpha"))
   (("PRED" 77))
  ))

; *** Lexer Definition ***
(define lexer
   (make-lexer
    terminal-table
    token-nrs
))


; *** Shortcut Definition ***
(define (pf string)
   (parser (lexer (string-reader string)) myerror))


(define (parse-file filename)
  (let ((parse-port
    (lambda (port)
      (parser (lexer (port-reader filename port)) myerror))))
    (call-with-input-file filename parse-port)))


; *** Add-Token Definition ***
(define add-token
   (make-add-token
    terminal-table
    token-nrs
))

; *** Remove-Token Definition ***
(define remove-token
   (make-remove-token
    terminal-table
    token-nrs
))

; *** Is-Token? Definition ***
(define is-token?
   (make-is-token?
    terminal-table
    token-defs
))

; *** Display-Tokens Definition ***
(define (display-tokens)
   (lexer-info
    terminal-table
    token-nrs
))

